﻿--[[---------------------------------------------------------------------------

Copyright (c) 2008 by K. Scott Piel 
All Rights Reserved

E-mail: < kscottpiel@gmail.com >
Web:    < http://www.scottpiel.com >

This file is part of nUI.

    nUI is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    nUI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with nUI.  If not, see <http://www.gnu.org/licenses/>.
	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--]]---------------------------------------------------------------------------

-- the possess bar frame

nUI_PossessBar = CreateFrame( "Frame", "nUI_PossessBar", PossessBarFrame );

nUI_PossessBar:SetBackdrop(
	{
		bgFile   = "Interface\\AddOns\\nUI\\Art\\nUI_BevelboxBg.blp", 
		edgeFile = "Interface\\AddOns\\nUI\\Art\\nUI_BevelboxBorder.blp", 
		tile     = true, 
		tileSize = 1, 
		edgeSize = 12, 
		insets   = {left = 0, right = 0, top = 0, bottom = 0},
	}
);

-- button initialization

nUI_PossessBar.Buttons = {};

for i=1,NUM_POSSESS_SLOTS do

	local button    = _G["PossessButton"..i];	

	nUI_PossessBar.Buttons[i] = button;
	
	button:SetParent( nUI_PossessBar );
	button:SetNormalTexture( "" );

	button.nUI_CachedSetPoint       = button.SetPoint;
	button.nUI_CachedClearAllPoints = button.ClearAllPoints;
	button.nUI_CachedSetAllPoints   = button.SetAllPoints;
	
	button.SetPoint       = function() end;
	button.SetAllPoints   = function() end;
	button.ClearAllPoints = function() end;
	
end

-- manage the layout of the Possess Bar

PossessBarFrame:SetParent( nUI_Dashboard );
PossessBarFrame.nUI_CachedSetScale = ShapeshiftBarFrame.SetScale;
PossessBarFrame.SetScale = function() end;

nUI_PossessBar:SetScript( "OnEvent", function() nUI_PossessBar:layoutFrame(); end );
nUI_PossessBar:RegisterEvent( "VARIABLES_LOADED" );
nUI_PossessBar:RegisterEvent( "DISPLAY_SIZE_CHANGED" );

nUI_PossessBar.layoutFrame = function()
				
	nUI:setScale();
				
	local btn_size    = nUI_PetBarLayout.btn_size * nUI.scale;
	local btn_gap     = nUI_PetBarLayout.gap * nUI.scale;
	local last_button;
	
	PossessBarFrame:nUI_CachedSetScale( 1.0 / nUI.scale );
	
	nUI_PossessBar:SetFrameStrata( nUI_Dashboard:GetFrameStrata() );
	nUI_PossessBar:SetFrameLevel( nUI_Dashboard:GetFrameLevel()+2 );

	nUI_PossessBar:SetHeight( btn_size * 1.1 );
	nUI_PossessBar:SetWidth( (btn_size * 10) + (btn_gap * 9) + btn_size * 0.1 );
	nUI_PossessBar:SetPoint( nUI_PetBarLayout.anchor, nUI_Dashboard, "CENTER", nUI_PetBarLayout.xOfs * nUI.scale, nUI_PetBarLayout.yOfs * nUI.scale );
	
	for i=1,NUM_POSSESS_SLOTS do
		
		local button = nUI_PossessBar.Buttons[i];

		button:SetFrameStrata( nUI_PossessBar:GetFrameStrata() );
		button:SetFrameLevel( nUI_PossessBar:GetFrameLevel()+1 );
		button:SetScale( btn_size / button:GetWidth() );

		button:nUI_CachedClearAllPoints();
		
		if i == 1 then button:nUI_CachedSetPoint( "TOPLEFT", nUI_PossessBar, "TOPLEFT", btn_size * 0.1, -btn_size * 0.1 );
		else button:nUI_CachedSetPoint( "TOPLEFT", last_button, "TOPRIGHT", btn_gap, 0 );
		end

		last_button = button;
	end		
end