﻿--[[---------------------------------------------------------------------------

Copyright (c) 2008 by K. Scott Piel 
All Rights Reserved

E-mail: < kscottpiel@gmail.com >
Web:    < http://www.scottpiel.com >

This file is part of nUI.

    nUI is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    nUI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with nUI.  If not, see <http://www.gnu.org/licenses/>.
	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--]]---------------------------------------------------------------------------
	
-------------------------------------------------------------------------------
-- default layout values

nUI_ButtonBarLayout = 
{
	name       = "",		-- the base name for this bar and its buttons
	label      = "",		-- the plain text label for this bar 
	rows       = 1,			-- how many rows does this bar have? 0 < rows < n
	cols       = 12,		-- how many columns does this bar have? 0 < cols < n
	btn_size   = 30,		-- the horizontal and vertical size of the buttons
	btn_gap    = 2,			-- the spacing between the buttons
	key_ring   = "none",	-- where to display the keyring in this bar: none|left|right
	show_grid  = "no",		-- whether or not to display the button grid: yes|no|hover
	visible    = "yes",		-- whether or not the bar is visible by default: yes|no
	button_src = nil,		-- the base name of the existing button set we are replacting
	btn_type   = nil,		-- the type of buttons in this bar as per GetBindingKey()
	hotkeys    = "yes",		-- whether or not to display hotkey text on the buttons: yes|no
	counts     = "yes",		-- whether or not to display stack counts on the buttons: yes|no
	inherits   = nil,		-- what button type template the bar's buttons inherit, if any
	parent_bar = nil,		-- name of the parent Bliz action bar where applicable
	
	Origin =
	{
		anchor      = "CENTER",	-- the anchor point for locating the bar: "CENTER", "LEFT", etc.
		xOfs        = 0,		-- the horizontal offset from the center of the parent
		yOfs        = 0			-- the vertical offset from the center of the parent
	},
}

nUI.Class.ButtonBarLayout = nUI.Class:CreatePrototype();
local prototype           = nUI.Class.ButtonBarLayout.prototype;

-------------------------------------------------------------------------------
-- this may look a little like a PITA, but it makes it possible to add new values
-- at any time without having to parse the existing user config and insert, etc.

function prototype:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Origin then user_defined.Origin = {}; end
	
	self.name       = user_defined.name or nUI_ButtonBarLayout.name;
	self.label      = user_defined.label or nUI_ButtonBarLayout.label;
	self.rows       = tonumber( user_defined.rows or nUI_ButtonBarLayout.rows );
	self.cols       = tonumber( user_defined.cols or nUI_ButtonBarLayout.cols );
	self.btn_size   = tonumber( user_defined.btn_size or nUI_ButtonBarLayout.btn_size );
	self.btn_gap    = tonumber( user_defined.btn_gap or nUI_ButtonBarLayout.btn_gap );
	self.key_ring   = strlower( user_defined.key_ring or nUI_ButtonBarLayout.key_ring );
	self.show_grid  = strlower( user_defined.show_grid or nUI_ButtonBarLayout.show_grid );
	self.visible    = strlower( user_defined.visible or nUI_ButtonBarLayout.visible );
	self.hotkeys    = strlower( user_defined.hotkeys or nUI_ButtonBarLayout.hotkeys );
	self.counts     = strlower( user_defined.counts or nUI_ButtonBarLayout.counts );
	self.btn_type   = user_defined.btn_type or nUI_ButtonBarLayout.btn_type;
	self.inherits   = user_defined.inherits or nUI_ButtonBarLayout.inherits;
	self.button_src = user_defined.button_src or nUI_ButtonBarLayout.button_src;
	self.parent_bar = user_defined.parent_bar or nUI_ButtonBarLayout.parent_bar;
	
	self.Origin = 
	{
		anchor      = strupper( user_defined.Origin.anchor or nUI_ButtonBarLayout.Origin.anchor ),
		xOfs        = tonumber( user_defined.Origin.xOfs or nUI_ButtonBarLayout.Origin.xOfs ),
		yOfs        = tonumber( user_defined.Origin.yOfs or nUI_ButtonBarLayout.Origin.yOfs ),
	};
	
end
